<mat-card>
  <b><span>DANH SÁCH ĐƠN HÀNG</span></b>
</mat-card>
<hr />
<div class="responsive_table">
  <mat-form-field appearance="fill">
    <mat-label>Lọc theo trạng thái</mat-label>
    <mat-select
      [(ngModel)]="selectedStatus"
      (selectionChange)="applyFilterByStatus()"
    >
      <mat-option *ngFor="let status of statusOptions" [value]="status.value">
        {{ status.label }}
      </mat-option>
    </mat-select>
  </mat-form-field>
  <table
    mat-table
    [dataSource]="dataSource"
    class="mat-elevation-z8 custom-table"
  >
    <ng-container matColumnDef="orderCode">
      <th mat-header-cell *matHeaderCellDef class="bold-header">MÃ ĐƠN HÀNG</th>
      <td mat-cell *matCellDef="let element">{{ element.orderCode }}</td>
    </ng-container>

    <ng-container matColumnDef="orderDate">
      <th mat-header-cell *matHeaderCellDef class="bold-header">NGÀY ĐẶT</th>
      <td mat-cell *matCellDef="let element">{{ element.orderDate }}</td>
    </ng-container>

    <ng-container matColumnDef="products">
      <th mat-header-cell *matHeaderCellDef class="bold-header">
        SẢN PHẨM ĐẶT
      </th>
      <td mat-cell *matCellDef="let element" class="product-cell">
        <div
          *ngFor="let product of element.productDetails"
          class="product-item"
        >
          <img [src]="product.image" alt="" />
          <div class="product-info">
            <span style="font-weight: bold">{{ product.name }}</span>
            <span></span>
            <span style="color: red">
              {{ product.price | currency : "VND" }}</span
            >
            <span>SỐ LƯỢNG ĐẶT: {{ product.quantity }}</span>
            <span style="color: red"
              >THÀNH TIỀN: {{ product.total | currency : "VND" }}</span
            >
          </div>
        </div>
      </td>
    </ng-container>

    <ng-container matColumnDef="totalAmount">
      <th mat-header-cell *matHeaderCellDef class="bold-header">TỔNG TIỀN</th>
      <td mat-cell *matCellDef="let element" style="color: green">
        {{ element.totalAmount | currency : "VND" : true : "1.0-0" }}
      </td>
    </ng-container>

    <ng-container matColumnDef="status">
      <th mat-header-cell *matHeaderCellDef class="bold-header">TRẠNG THÁI</th>
      <td mat-cell *matCellDef="let element">
        {{ getStatusText(element.status) }}
      </td>
    </ng-container>

    <ng-container matColumnDef="edit">
      <th mat-header-cell *matHeaderCellDef class="action-link">THAO TÁC</th>
      <td mat-cell *matCellDef="let element">
        <div>
          <button
            mat-icon-button
            color="primary"
            matTooltip="Xuất thông tin đơn hàng"
            (click)="downloadReportAction(element)"
          >
            <mat-icon>description</mat-icon>
          </button>
          <!-- Nút chỉnh sửa -->
          <ng-container *ngIf="element.editing; else showButton">
            <mat-form-field appearance="fill">
              <mat-label>Chọn trạng thái</mat-label>
              <mat-select [(ngModel)]="element.newStatus">
                <mat-option
                  *ngFor="let option of statusOptions"
                  [value]="option.value"
                >
                  {{ option.label }}
                </mat-option>
              </mat-select>
            </mat-form-field>
            <button
              mat-icon-button
              color="primary"
              matTooltip="Lưu"
              (click)="saveStatus(element)"
            >
              <mat-icon>done</mat-icon>
            </button>
            <button
              mat-icon-button
              color="warn"
              matTooltip="Hủy"
              (click)="cancelEdit(element)"
            >
              <mat-icon>cancel</mat-icon>
            </button>
          </ng-container>
          <ng-template #showButton>
            <button
              mat-icon-button
              color="primary"
              matTooltip="Sửa"
              (click)="startEdit(element)"
            >
              <mat-icon>edit</mat-icon>
            </button>
          </ng-template>
        </div>
      </td>
    </ng-container>

    <tr mat-header-row *matHeaderRowDef="displayedColumns; sticky: true"></tr>
    <tr mat-row *matRowDef="let row; columns: displayedColumns"></tr>
  </table>
  <mat-paginator
    [pageSizeOptions]="[5, 10, 25, 100]"
    showFirstLastButtons
  ></mat-paginator>
</div>
